#!/usr/bin/perl -w

use standard_format;


if($#ARGV != 1)
{
    print STDERR "USAGE:  gridg.pl NumOfRouters NumOfHosts\n";
    exit;
}

my $numrouter = shift;
my $numhost = shift;
my $outfile = "./GridG-out";
my ($con1, $con2);

if($numrouter >= $numhost)
{
    print STDERR "Warning! Possiblely bad topology: number of routers
is bigger than number of hosts.\n";
}

#NM = SW*2.5
#SM = NM*const1 = (SW*2.5)*const1
#SW+NM*SM = SW+ (SW*2.5)*((SW*2.5)*const1) = numrouter

#NL = NM*const2
#NM*NL*SL = NM*NM*const2*SL  = numhost

do {
    srand(time);
    $con1 = randGen(1, 3);
    $con2 = randGen(1, 4);
    
    $SW = int ((sqrt(1 + 25 * $con1 * $numrouter) - 1)/(12.5*$con1));
    $NM = int $SW * 2.6;
    $SM = int $NM * $con1;
    $NL = int $NM * $con2;
    $SL = int $numhost/($NM*$NL);
    $temp1 = ($SW+$NM*$SM);
    $temp2 = ($NM*$NL*$SL);
}while($SL <= 1);

#print STDERR "1 $NM $NL $SW $SM $SL\n";
print STDERR "Generating $temp1 routers, $temp2 hosts.\n";
`./tiers 1 $NM $NL $SW $SM $SL 1 1 1 1 1 | ./reshapeLAN.pl $SL | ./powerannotate.pl $SL | ./reshapeLink.pl > $outfile`;
print STDERR "Done! The data is in $outfile.\n"
