#!/usr/bin/perl -w


use standard_format;

my $infile = STDIN;
my $outfile = STDOUT;


sub SetupHashes 
{
    my ($line, $hashName, @keys, @values, $len, $hashlength, @TEMP);
    open (DistConf, "./distributation.conf") or die "Can't open config file distributation.conf: $!";

    while($line = <DistConf>) {
	if(($line =~ /^\s+\b/) or ($line =~ /^#/)) {
	    ; #do nothing
	}else{
	    chomp $line;
	    @TEMP = split(/\s+/, $line);
	    if($TEMP[0] =~ /RATIO-\w+/)
	    {
		@keys = @TEMP;
		$hashName = $keys[0];
		$hashlength = @keys;
		
		for($len=2; $len<$hashlength; $len++)
		{
		    $keys[$len] = $keys[$len] + $keys[$len-1];
		}
	    }elsif($TEMP[0] =~ /ALPHA/){
		#$ALPHA = $TEMP[1];
	    }elsif($TEMP[0] =~ /POWER/){
		#$POWER = $TEMP[1];
	    }elsif (($TEMP[0] !~ /RATIO-\w+/) && ($TEMP[0] !~ /#\w+/)) {
		  @values = @TEMP;
		  for($len=1; $len < $hashlength; $len++)
		     {
			 ${$hashName}{$keys[$len]} = $values[$len];
		     }
		} #elsif 
	} #end of else
       } #while
}
    

sub match {
    my ($myhash, $myseed) = @_;
    my (@temp, $val);
    @temp = sort {$a <=> $b} keys(%{$myhash});
    foreach $val (@temp)
    {
	if($myseed < $val)
	{
	    #print "seed is : $myseed, val is : $val, return val is : ${$myhash}{$val} \n"; 
	    return ${$myhash}{$val}; 
	}
    }

    print STDERR "Match failed! probablely wrong.\n";
    return -1;
}


my $LATseed = 0;
my $BWseed = 0;
SetupHashes(); 
srand(time);
while($line = <$infile>)
{
    if(!($line =~ /^LINK/))
       { 
	   print $outfile $line;
       }elsif($line =~ /^LINK/){
	   $LATseed = rand100();
	   $BWseed = rand100();
	   ($type, $from, $to, $lat, $bw, $fromtype, $totype, $sta) = split(/\s+/, $line);
	   if($fromtype == 0)
	   {
	       $lat =  match(qw(RATIO-WAN-LINK-LAT), $LATseed);
	       $bw =  match(qw(RATIO-WAN-LINK-BW), $BWseed);
	   }elsif($fromtype == 1){
	       $lat =  match(qw(RATIO-MAN-LINK-LAT), $LATseed);
	       $bw =  match(qw(RATIO-MAN-LINK-BW), $BWseed);
	   }elsif($fromtype == 2){
	       $lat =  match(qw(RATIO-LAN-LINK-LAT), $LATseed);
	       $bw =  match(qw(RATIO-LAN-LINK-BW), $BWseed);
	   }else{
	       $lat =  match(qw(RATIO-INTER-LINK-LAT), $LATseed);
	       $bw =  match(qw(RATIO-INTER-LINK-BW), $BWseed);
	   }

	   print $outfile "$type $from $to $lat $bw $fromtype $totype $sta\n";
       }
    
}#end of while



