package rules;
require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(ARCHandOSandCPUrule NUMCPUandMEMandDISKrule OSVENDORrule LOADrule AllOtherRules promotionProb promotionMemRate promotionDiskRate degradeProb degradeMemRate degradeDiskRate ifOSconcentration);




#This class of rules govens the relation between architecture, OS, number of CPU and CPU speed
sub ARCHandOSandCPUrule
{
    my($arch, $OS, $numcpu, $cpuspeed);
    ($arch, $OS, $numcpu, $cpuspeed) = @_;
    
    #add rules here
    #example rule: Intel arch can't support more than 4 CPU/host
    if(($arch eq "IA32") || ($arch eq "IA64")){
	if($numcpu > 4) {
	    return 0;
	}
    }
    #example rule: Max num of CPU is 1024
    if($numcpu > 1024) {
	return 0;
    }

    #rules end here

    return 1;
}



#This class of rules govens the relation among architecture, OS, number of CPU, CPU MHZ, mem and disk.
#Most efficient when describing relation among number of CPU, mem and disk. 
#When arch, OS and cpuspeed are involoved, it may run slower.
sub NUMCPUandMEMandDISKrule
{
    my($arch, $OS, $numcpu, $cpuspeed, $mem, $disk);
    ($arch, $OS, $numcpu, $cpuspeed, $mem, $disk) = @_;

    #add rules here
    #example rule: every CPU must have more than 64M mem, and less than 4G mem
    if(($mem/$numcpu < 64) || ($mem/$numcpu > 4096 )) { 
	return 0;
    }
    #example rule: every CPU must have more than 10G disk
    if($disk/$numcpu < 10) { 
	return 0;
    }

    #rules end here
    
    return 1;
}


#This class of rules govens the relation between OS and OSvendor
sub OSVENDORrule
{
    my($OS, $osvendor);
    ($OS, $osvendor) = @_;
    
    #add rules here
    

    #rules end here

    return 1;
}


sub LOADrule
{
    my($type,$nodenum,$x,$y,$nettype,$numcpu,$cpuspeed,$mem,$disk,$arch,$OS,$osvendor);
    ($type,$nodenum,$x,$y,$nettype,$numcpu,$cpuspeed,$mem,$disk,$arch,$OS,$osvendor) = @_;

    #add rules here
    

    #rules end here

    return 1;
}






########################################################
#      All other user defined rules goes here          #
########################################################
sub AllOtherRules
{
    my($type,$nodenum,$x,$y,$nettype,$numcpu,
     $cpuspeed,$mem,$disk,$arch,$OS,$osvendor,$load) = @_;
    my $IfSatisfied = 1;

    #rules are added here
    #Example rule: if NumCPU >= 32, then mem must be larger than or equal to 4096 
    if($numcpu >= 32 && $mem < 4096){
	$IfSatisfied = 0; 
    }

    #rules ended here


    return $IfSatisfied;
}


########################################################
sub promotionProb
{
    my($numcpu, $maxcpu, $mincpu);
    ($numcpu, $maxcpu, $mincpu) = @_;
    my $pp100;
    
    $pp100 = 100 * sqrt(($numcpu-$mincpu)/($maxcpu-$mincpu));  
    #$pp100 = 100 * ($numcpu-$mincpu)/($maxcpu-$mincpu);  
    #$pp100 = 0;  
    return $pp100;
}


sub promotionMemRate
{
    my($numcpu, $maxcpu, $mincpu, $mem);
    ($numcpu, $maxcpu, $mincpu, $mem) = @_;
    
    my $newmem = $mem * 2;

    return $newmem;
}



sub promotionDiskRate
{
    my($numcpu, $maxcpu, $mincpu, $disk);
    ($numcpu, $maxcpu, $mincpu, $disk) = @_;
    
    my $newdisk = $disk * 2;

    return $newdisk;
}








sub degradeProb
{
    my($numcpu, $maxcpu, $mincpu);
    ($numcpu, $maxcpu, $mincpu) = @_;
    my $dp100;
    my $someProb = 30;
    
    $dp100 = 100 - 100 * sqrt (($numcpu-1)/(4-1)) - $someProb;
    return $dp100;
}




sub degradeMemRate
{
    my($numcpu, $maxcpu, $mincpu, $mem);
    ($numcpu, $maxcpu, $mincpu, $mem) = @_;
    my $newmem;

    $newmem = $mem/2;
    return $newmem;
}



sub degradeDiskRate
{
    my($numcpu, $maxcpu, $mincpu, $disk);
    ($numcpu, $maxcpu, $mincpu, $disk) = @_;
    my $newdisk;

    $newdisk = $disk/2;
    return $newdisk;
}



###################################################
###This decides if the OS concentration is imposed
###################################################

sub ifOSconcentration
{
    my($ifOS);

    $ifOS = 1; 
    #impose the OS concentration in subnets

    #$ifOS = 0;
    #does not impose the OS concentration in subnets

    return $ifOS;
}










